const util = require('./util')

class STT {
    escape(v) {
        return util.isUndefined(v) ? '' : v.toString().replace(/@/g, '@A').replace(/\//g, '@S')
    }

    unescape(v) {
        return util.isUndefined(v) ? '' : v.toString().replace(/@A/g, '@').replace(/@S/g, '/')
    }

    serialize(records) {
        if (records === null) {
            return '';
        }
        if (typeof records === 'string') {
            return this.escape(records)
        }
        if (typeof records === 'number') {
            return records.toString()
        }
        let serializedString = '';
        if (Array.isArray(records)) {
            return records.map(record => this.escape(this.serialize(record))).join('')
        }
        // Object.entries(records).forEach(([key, value]) => {
        //     serializedString = serializedString + this.escape(this.serialize(key)) + '@=' + this.escape(this.serialize(value)) + '/'
        // });

        return Object.entries(records).reduce((prev, [key, value], index) => {
            console.log(key, value)
            prev
            return `${prev}${this.escape(this.serialize(key))}@=${this.escape(this.serialize(value))}/`
        }, '')

        return serializedString;


        // if (util.isObject(raw)) {
        //     return Object.keys(raw).map(k => `${k}@=${this.escape(this.serialize(raw[k]))}`).join('/')
        // } else if (Array.isArray(raw)) {
        //     return raw.map(v => `${this.escape(this.serialize(v))}/`).join('')
        // } else if (util.isString(raw) || util.isNumber(raw)) {
        //     return raw.toString()
        // }
    }

    deserialize(raw) {
        if (raw.includes('//')) {
            // console.log("raw.includes('//')", raw)
            return raw.split('//').filter(e => e !== '').map(item => this.deserialize(item))
        }

        if (raw.includes('@=')) {
            return raw.split('/').filter(e => e !== '').reduce((o, s) => {
                const [k, v] = s.split('@=')
                o[k] = this.deserialize(this.unescape(v))
                return o
            }, {})
        } else if (raw.includes('@A=')) {
            return this.deserialize(this.unescape(raw))
        } else {
            return raw.toString()
        }
    }
}

module.exports = new STT()